Name:           fcoe-utils
Version:        1.0.7
Release:        4%{?dist}
Summary:        Fibre Channel over Ethernet utilities

Group:          Applications/System
License:        GPLv2
URL:            http://www.open-fcoe.org
Source0:        http://www.open-fcoe.org/openfc/downloads/%{name}-%{version}.tar.gz
Patch0:         fcoe-utils-1.0.7-init.patch
Patch1:         fcoe-utils-1.0.7-free.patch
Patch2:         fcoe-utils-1.0.7-init-condrestart.patch
Patch3:         fcoe-utils-1.0.7-longOpts.patch
Patch4:         fcoe-utils-1.0.7-init-fcoemon.patch
Patch5:         fcoe-utils-1.0.7-make-init.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:    libhbaapi-devel
Requires:         libhbalinux
Requires(post):   chkconfig
Requires(preun):  chkconfig initscripts
Requires(postun): initscripts

%description
Fibre Channel over Ethernet utilities
fcoeadm - command line tool for configuring FCoE interfaces
fcoemon - service to configure DCB Ethernet QOS filters, works with dcbd

%prep
%setup -q
%patch0 -p1 -b .initPatch
%patch1 -p1 -b .freePatch
%patch2 -p1 -b .condrestartPatch
%patch3 -p1 -b .longOpts
%patch4 -p1 -b .initFcoemon
%patch5 -p1 -b .makeInit


%build
%configure --without-dcb
make %{?_smp_mflags}


%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{_initrddir}
mv $RPM_BUILD_ROOT/etc/init.d/fcoe $RPM_BUILD_ROOT%{_initrddir}/fcoe
rm -rf $RPM_BUILD_ROOT/etc/init.d


%clean
rm -rf $RPM_BUILD_ROOT


%post
/sbin/chkconfig --add fcoe

%triggerun -- fcoe-utils <= 1.0.7-3
if [ -x %{_initrddir}/fcoe-utils ]; then
  /sbin/service fcoe-utils stop > /dev/null 2>&1
  /sbin/chkconfig fcoe-utils off
  # now copy an updated file, which we need to do proper condrestart
  sed 's/\/var\/lock\/subsys\/fcoe/\/var\/lock\/subsys\/fcoe-utils/' %{_initrddir}/fcoe > %{_initrddir}/fcoe-utils
fi

%triggerpostun -- fcoe-utils <= 1.0.7-3
if [ -x %{_initrddir}/fcoe-utils ]; then
  rm -f %{_initrddir}/fcoe-utils # this file should be already deleted, but just in case ...
fi

%preun
if [ $1 = 0 ]; then
        /sbin/service fcoe stop > /dev/null 2>&1
        /sbin/chkconfig --del fcoe
fi

%postun
if [ "$1" -ge "1" ]; then
        /sbin/service fcoe condrestart > /dev/null  2>&1 || :
fi


%files
%defattr(-,root,root,-)
%doc README COPYING
%{_sbindir}/*
%{_mandir}/man8/*
%{_sysconfdir}/fcoe/scripts/fcoeplumb
%dir %{_sysconfdir}/fcoe/
%dir %{_sysconfdir}/fcoe/scripts/
%config(noreplace) %{_sysconfdir}/fcoe/config
%config(noreplace) %{_sysconfdir}/fcoe/cfg-ethx
%{_initrddir}/fcoe


%changelog
* Mon Jun 1 2009 Jan Zeleny <jzeleny@redhat.com> - 1.0.7-4
- backported some patches from Fedora:
  503162 - renaming service from fcoe-utils to fcoe
  503164 - adding libhbalinux as dependency
  503165 - invalid free() call
  503167 - correction of long options in fcoeadm
- patch to install proper init script and correction of that
  script in order to allow functionality without fcoemon

* Wed Apr 8 2009 Jan Zeleny <jzeleny@redhat.com> - 1.0.7-3
- more minor corrections in spec file

* Thu Apr 2 2009 Jan Zeleny <jzeleny@redhat.com> - 1.0.7-2
- minor corrections in spec file
- moved init script to correct location
- correction in the init script (chkconfig directives)

* Mon Mar 2 2009 Chris Leech <christopher.leech@intel.com> - 1.0.7-1
- initial rpm build of fcoe tools

